(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  24, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  18, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, italic, e6,  14, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  18, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  14, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  12, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M42, N23, bold, L-4,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-4,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R32768, L-4,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-4,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, B32768, L-4,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	showRuler; currentKernel; 
]
:[font = title; inactive; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
Init-File: Belegen von Elementmatrizen des MKS
:[font = subsubtitle; inactive; preserveAspect; plain; bold; italic; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
Dieses File muss vor dem Aufbau des MKS-Systematrizen gestartet werden!
Beachte: Funktionen wurden nur fuer 2D-Modelle getestet.
:[font = subsubtitle; inactive; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
COPYRIGHT Prof. Dr. Oskar Wallrapp, Fachhochschule Muenchen. April 1999
:[font = input; initialization; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
*)
Off[General::"spell",General::"spell1"]
(*
:[font = text; inactive; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
NullMatrix[n1_,n2_]    erzeugt eine n1 x n2-Null-Matrix
Tilde[v1(3)]    erzeugt aus v1(3) eine 3x3 Matrix nach der Vorschrift des Tilde-operator
Numbernfs[gtyp] gibt die Zahl der Freiheitsgrade des Gelenks D, S, F,DS wieder
:[font = input; initialization; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981; startGroup]
*)
NullMatrix[n1_,n2_] := Table[0,{n1},{n2}]

Tilde[v1_?ListQ]:=
		{{0,-v1[[3]],v1[[2]]},
	     {v1[[3]],0,-v1[[1]]},
	     {-v1[[2]],v1[[1]],0}} /; Length[v1]==3

Numbernfs[gtyp_] := If[gtyp===D,1,
                     If[gtyp===S,1,
                      If[gtyp===DS,2,
                       If[gtyp===F ,0]]]]

(*
:[font = text; inactive; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
Numbernzi[btyp,nqi]    gibt die Zahl der Koordinaten des Koerpers starr2d, starr3d, elastisch2D, elastisch3D wieder,
                                                      nqi ist die Zahl der Verformungskoordinaten
VektorzIi[btyp_,nqi_,indexi_] erzeugt eine nzi x 1 Matrix der Systemvariablen der Lage: btyp der Typ des Koerpers, nqi ist die Zahl der
  				                                                Verformungskoordinaten, indexi die Koerpernummer.
 VektorzIIi[btyp_,nqi_,indexi_] erzeugt eine nzi x 1 Matrix der Systemvariablen der Geschwindigkeit: 
 
 VektorzIIdi[btyp_,nqi_,indexi_] erzeugt eine nzi x 1 Matrix der Systemvariablen der Beschleunigung: 
:[font = input; initialization; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
*)
Numbernzi[btyp_,nqi_] :=
     If[btyp===s2D, 3,
     If[btyp===s3D, 6,
     If[btyp===e2D, 3+nqi,
     If[btyp===e3D, 6+nqi]]]]
     
(*
:[font = input; initialization; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
*)
qFeld[indexi_] := {q1[indexi],q2[indexi],q3[indexi],q4[indexi],q5[indexi],q6[indexi],q7[indexi],q8[indexi],q9[indexi],q10[indexi],          
                   q11[indexi],q12[indexi],q13[indexi],q14[indexi],q15[indexi],q16[indexi],q17[indexi],q18[indexi],q19[indexi],q20[indexi],
                   q21[indexi],q22[indexi],q23[indexi],q24[indexi],q25[indexi],q26[indexi],q27[indexi],q28[indexi],q29[indexi],q30[indexi]};
(*
:[font = input; initialization; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
*)
qdFeld[indexi_] := {qd1[indexi], qd2[indexi], qd3[indexi], qd4[indexi], qd5[indexi], qd6[indexi], qd7[indexi], qd8[indexi], qd9[indexi],qd10[indexi],          
                   qd11[indexi],qd12[indexi],qd13[indexi],qd14[indexi],qd15[indexi],qd16[indexi],qd17[indexi],qd18[indexi],qd19[indexi],qd20[indexi],
                   qd21[indexi],qd22[indexi],qd23[indexi],qd24[indexi],qd25[indexi],qd26[indexi],qd27[indexi],qd28[indexi],qd29[indexi],qd30[indexi]};
(*
:[font = input; initialization; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
*)
qddFeld[indexi_] := {qdd1[indexi], qdd2[indexi], qdd3[indexi], qdd4[indexi], qdd5[indexi], qdd6[indexi], qdd7[indexi], qdd8[indexi], qdd9[indexi],qdd10[indexi],          
                    qdd11[indexi],qdd12[indexi],qdd13[indexi],qdd14[indexi],qdd15[indexi],qdd16[indexi],qdd17[indexi],qdd18[indexi],qdd19[indexi],qdd20[indexi],
                    qdd21[indexi],qdd22[indexi],qdd23[indexi],qdd24[indexi],qdd25[indexi],qdd26[indexi],qdd27[indexi],qdd28[indexi],qdd29[indexi],qdd30[indexi]};
(*
:[font = input; initialization; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
*)
VektorzIi[btyp_,nqi_,indexi_] :=
     If[btyp===s2D, {rhox[indexi],rhoy[indexi],al[indexi]},
     If[btyp===s3D, {rhox[indexi],rhoy[indexi],rhoz[indexi],alx[indexi],aly[indexi],alz[indexi]},
     If[btyp===e2D, Join[{rhox[indexi],rhoy[indexi],al[indexi]},qFeld[indexi][[Range[nqi]]]],
     If[btyp===e3D, Join[{rhox[indexi],rhoy[indexi],rhoz[indexi],alx[indexi],aly[indexi],alz[indexi]},qFeld[indexi][[Range[nqi]]]]
     ]]]]
(*
:[font = input; initialization; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
*)
VektorzIIi[btyp_,nqi_,indexi_] :=
     If[btyp===s2D,      {vx[indexi],vy[indexi],oz[indexi]},
     If[btyp===s3D,      {vx[indexi],vy[indexi],vz[indexi],ox[indexi],oy[indexi],oz[indexi]},
     If[btyp===e2D, Join[{vx[indexi],vy[indexi],oz[indexi]},qdFeld[indexi][[Range[nqi]]]],
     If[btyp===e3D, Join[{vx[indexi],vy[indexi],vz[indexi],ox[indexi],oy[indexi],oz[indexi]},qdFeld[indexi][[Range[nqi]]]]
     ]]]]
(*
:[font = input; initialization; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
*)
VektorzIIdi[btyp_,nqi_,indexi_] :=
     If[btyp===s2D,      {vdx[indexi],vdy[indexi],ozd[indexi]},
     If[btyp===s3D,      {vdx[indexi],vdy[indexi],vdz[indexi],odx[indexi],ody[indexi],odz[indexi]},
     If[btyp===e2D, Join[{vdx[indexi],vdy[indexi],ozd[indexi]},qddFeld[indexi][[Range[nqi]]]],
     If[btyp===e3D, Join[{vdx[indexi],vdy[indexi],vdz[indexi],odx[indexi],ody[indexi],odz[indexi]},qddFeld[indexi][[Range[nqi]]]]
     ]]]]
(*
:[font = input; initialization; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
*)
MatrixZi[btyp_,nqi_] :=
       If[btyp===s3D||btyp===e3D,Join[
                                 Transpose[Join[IdentityMatrix[3],-Tilde[{rhox,rhoy,rhoz}],Table[0,{nqi},{3}]]],
                                 Transpose[Join[Table[0,{3},{3+nqi}],IdentityMatrix[3+nqi]]]], 
       If[btyp===s2D||btyp===e2D,Join[
                                 Transpose[Join[{{1, 0, 0},
                                                 {0, 1, 0},
                                                 {rhoy,-rhox,1}},Table[0,{nqi},{3}]]],
                                 Transpose[Join[Table[0,{3},{nqi}],IdentityMatrix[nqi]]]] ]] 

MatrixAi[btyp_,indexi_] :=  
       If[btyp===s3D||btyp===e3D,{{Null},
                                  {Null}, 
                                  {Null}},
       If[btyp===s2D||btyp===e2D,{{ Cos[al[indexi]],  Sin[al[indexi]], 0},
                                  {-Sin[al[indexi]],  Cos[al[indexi]], 0}, 
                                  { 0,                0,               1}}]]

(*
:[font = input; initialization; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
*)
VektorrhoI[btyp_,Rvec_,Aimat_,indexi_,uivec_] :=
       If[btyp===s2D||btyp===s3D, Transpose[Aimat].({rhox[indexi],rhoy[indexi],0} + Rvec),
       If[btyp===e2D||btyp===e3D, Transpose[Aimat].({rhox[indexi],rhoy[indexi],0} + Rvec + uivec)]] 


(*
:[font = text; inactive; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
MatrixTtki[btyp_,indexk_] liefert eine 3 x nzi -Matrix der Translation fuer Knoten indexk am Koerper i, je nach btyp.
MatrixTrki[btyp_,indexk_] liefert eine 3 x nzi -Matrix der Rotation fuer Knoten indexk am Koerper i, je nach btyp.
Vektorzetatki[btyp_,indexk_,indexi_] liefert eine 3 x 1 -Matrix zetatki der Translation fuer Knoten indexk am Koerper i, je nach btyp.
Vektorzetarki[btyp_,indexk_,indexi_] liefert eine 3 x 1 -Matrix zetarki der Rotation fuer Knoten indexk am Koerper i, je nach btyp.
Vektorrhoki[btyp,k,i], ] bestimmt Ortsvektor zum Knoten k am Koerper i, je nach btyp
MatrixDki[btyp_,indexk_,gammaki_,nvec_] liefert die Drehmatrix Dki = (E-Tilde(thetaki)).Gammaki   

;[s]
2:0,0;684,1;685,-1;
2:1,13,9,Times,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; initialization; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
*)
MatrixTtki[btyp_,indexk_,numnzi_,MatPhix_,MatPhiy_,MatPhiz_] :=  
       If[btyp===s3D,{{1, 0, 0, 0, Rz[indexk], -Ry[indexk]},
                      {0, 1, 0, -Rz[indexk], 0, Rx[indexk]}, 
                      {0, 0, 1, Ry[indexk], -Rx[indexk], 0}}, 
       If[btyp===e3D,{{1, 0, 0, 0, (Rz[indexk]+uz[indexk]), -(Ry[indexk]+uy[indexk]), MatPhix},
                      {0, 1, 0, -(Rz[indexk]+uz[indexk]), 0, (Rx[indexk]+ux[indexk]), MatPhiy}, 
                      {0, 0, 1, (Ry[indexk]+uy[indexk]), -(Rx[indexk]+ux[indexk]), 0, MatPhiz}}, 
       If[btyp===s2D,{{1, 0,  -Ry[indexk]},
                      {0, 1,   Rx[indexk]}, 
                      {0, 0,  0          }}, 
       If[btyp===e2D,{{1, 0, -(Ry[indexk]+uy[indexk]), MatPhix},
                      {0, 1,  (Rx[indexk]+ux[indexk]), MatPhiy},
                      Table[0,{numnzi}]}]]]]
(*
:[font = input; initialization; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
*)
MatrixTrki[btyp_,indexk_,numnzi_,MatPsix_,MatPsiy_,MatPsiz_] :=  
       If[btyp===s3D,Transpose[Join[NullMatrix[3,3],IdentityMatrix[3]]], 
       If[btyp===e3D,Transpose[Join[NullMatrix[3,3],IdentityMatrix[3],Transpose[{{MatPsix},{MatPsiy},{MatPsiz}}]]],
       If[btyp===s2D,{{0, 0,  0},
                      {0, 0,  0}, 
                      {0, 0,  1}}, 
       If[btyp===e2D,{Table[0,{numnzi}],
                      Table[0,{numnzi}],
                      {0, 0,  1, MatPsiz}}]]]]

(*
:[font = input; initialization; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
*)
Vektorzetatki[btyp_,indexk_,indexi_] :=   
       If[btyp===e3D,{-(oz[indexi]*(  oz[indexi]*(Rx[indexk]+ux[indexk])  - ox[indexi]*(Rz[indexk]+uz[indexk]) + 2*udy[indexk] + vy[indexi])) + oy[indexi]*(-(oy[indexk]*(Rx[indexk]+ux[indexk])) + ox[indexi]*(Ry[indexk]+uy[indexk]) + 2*udz[indexk] + vz[indexi]),
                        oz[indexi]*(-(oz[indexi]*(Ry[indexk]+uy[indexk])) + oy[indexi]*(Rz[indexk]+uz[indexk]) + 2*udx[indexk] + vx[indexi])  - ox[indexi]*(-(oy[indexk]*(Rx[indexk]+ux[indexk])) + ox[indexi]*(Ry[indexk]+uy[indexk]) + 2*udz[indexk] + vz[indexi]), 
                      -(oy[indexi]*(-(oz[indexi]*(Ry[indexk]+uy[indexk])) + oy[indexi]*(Rz[indexk]+uz[indexk]) + 2*udx[indexk] + vx[indexi])) + ox[indexi]*(  oz[indexk]*(Rx[indexk]+ux[indexk])  - ox[indexi]*(Rz[indexk]+uz[indexk]) + 2*udy[indexk] + vy[indexi])},
       If[btyp===s3D,{-(oz[indexi]*(  oz[indexi]*Rx[indexk]  - ox[indexi]*Rz[indexk] + vy[indexi])) + oy[indexi]*(-(oy[indexi]*Rx[indexk]) + ox[indexi]*Ry[indexk] + vz[indexi]),
                        oz[indexi]*(-(oz[indexi]*Ry[indexk]) + oy[indexi]*Rz[indexk] + vx[indexi])  - ox[indexi]*(-(oy[indexi]*Rx[indexk]) + ox[indexi]*Ry[indexk] + vz[indexi]), 
                      -(oy[indexi]*(-(oz[indexi]*Ry[indexk]) + oy[indexi]*Rz[indexk] + vx[indexi])) + ox[indexi]*(  oz[indexi]*Rx[indexk]  - ox[indexi]*Rz[indexk] + vy[indexi])},
       If[btyp===s2D,{-(oz[indexi]*(  oz[indexi]*Rx[indexk]  + vy[indexi])) ,
                        oz[indexi]*(-(oz[indexi]*Ry[indexk]) + vx[indexi])  , 
                        0 },
       If[btyp===e2D,{-(oz[indexi]*(  oz[indexi]*(Rx[indexk]+ux[indexk])  + 2*udy[indexk] + vy[indexi])),
                        oz[indexi]*(-(oz[indexi]*(Ry[indexk]+uy[indexk])) + 2*udx[indexk] + vx[indexi]) , 
                        0 }]]]]

Vektorzetarki[btyp_,indexk_,indexi_] :=   
       If[btyp===s3D||btyp===s2D,{0,0,0},
       If[btyp===e3D,{-(oz[indexi]*thetady[indexk]) + oy[indexi]*thetadz[indexk],
                        oz[indexi]*thetadx[indexk]  - ox[indexi]*thetadz[indexk], 
                      -(oy[indexi]*thetadx[indexk]) + ox[indexi]*thetady[indexk]},
       If[btyp===e2D,{  0,0,0}]]]
(*
:[font = input; initialization; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
*)
Vektorrhoki[btyp_,indexk_,indexi_] :=   
       If[btyp===e3D,{rhox[indexi] + (Rx[indexk]+ux[indexk]), rhoy[indexi] + (Ry[indexk]+uy[indexk]), rhoz[indexi] + (Rz[indexk]+uz[indexk])},
       If[btyp===s3D,{rhox[indexi] + Rx[indexk], rhoy[indexi] + Ry[indexk], rhoz[indexi] + Rz[indexk]},
       If[btyp===s2D,{rhox[indexi] + Rx[indexk], rhoy[indexi] + Ry[indexk], 0},
       If[btyp===e2D,{rhox[indexi] + (Rx[indexk]+ux[indexk]), rhoy[indexi] + (Ry[indexk]+uy[indexk]), 0}]]]]
                      
                      
(*
:[font = input; initialization; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
*)
MatrixDki[btyp_,indexk_,gammaki_,nvec_?ListQ] :=   
       If[btyp===I  , Outer[Times,nvec,nvec] + (IdentityMatrix[3] - Outer[Times,nvec,nvec])*Cos[gammaki] - Tilde[nvec]*Sin[gammaki],
       If[btyp===e3D, Outer[Times,nvec,nvec] + (IdentityMatrix[3] - Outer[Times,nvec,nvec])*Cos[gammaki] - Tilde[nvec]*Sin[gammaki],
       If[btyp===s3D, {{Cos[thetaz[indexk]],Sin[thetaz[indexk]],0},{-Sin[thetaz[indexk]],Cos[thetaz[indexk]],0},{0,0,1}} . (Outer[Times,nvec,nvec] + (IdentityMatrix[3] - Outer[Times,nvec,nvec])*Cos[gammaki] - Tilde[nvec]*Sin[gammaki]),
       If[btyp===s2D, Outer[Times,nvec,nvec] + (IdentityMatrix[3] - Outer[Times,nvec,nvec])*Cos[gammaki] - Tilde[nvec]*Sin[gammaki], 
       If[btyp===e2D, {{Cos[thetaz[indexk]],Sin[thetaz[indexk]],0},{-Sin[thetaz[indexk]],Cos[thetaz[indexk]],0},{0,0,1}} . (Outer[Times,nvec,nvec] + (IdentityMatrix[3] - Outer[Times,nvec,nvec])*Cos[gammaki] - Tilde[nvec]*Sin[gammaki]) ]]]]] /; Length[nvec]==3
        
(*
:[font = text; inactive; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
MatrixMi[btyp_,indexi_] liefert eine nzi x nzi -Massenmatrix fuer Koerper indexi, je nach btyp. mi ist die Masse.
:[font = input; initialization; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
*)
MatrixMi[btyp_,indexi_] :=  
       If[btyp===s3D,{{mi, 0, 0, 0, mi cz[indexi], -mi cy[indexi]},
                      {0, mi, 0, -mi cz[indexi], 0, mi cx[indexi]}, 
                      {0, 0, mi, mi cy[indexi], -mi cx[indexi], 0}, 
                      {0, -mi cz[indexi], mi cy[indexi], Ixx[indexi], Ixy[indexi], Ixz[indexi]},
                      {mi cz[indexi], 0, -mi cx[indexi], Ixy[indexi], Iyy[indexi], Iyz[indexi]},
                      {-mi cy[indexi], mi cx[indexi], 0, Ixz[indexi], Iyz[indexi], Izz[indexi]}},
       If[btyp===e3D,{{mi, 0, 0, 0, mi cz[indexi], -mi cy[indexi], Ctx[indexi]},
                      {0, mi, 0, -mi cz[indexi], 0, mi cx[indexi], Cty[indexi]}, 
                      {0, 0, mi, mi cy[indexi], -mi cx[indexi], 0, Ctz[indexi]}, 
                      {0, -mi cz[indexi], mi cy[indexi], Ixx[indexi], Ixy[indexi], Ixz[indexi], Crx[indexi]},
                      {mi cz[indexi], 0, -mi cx[indexi], Ixy[indexi], Iyy[indexi], Iyz[indexi], Cry[indexi]},
                      {-mi cy[indexi], mi cx[indexi], 0, Ixz[indexi], Iyz[indexi], Izz[indexi], Crz[indexi]},
                      {Ctx[indexi],Cty[indexi],Ctz[indexi],Crx[indexi],Cry[indexi],Crz[indexi], 1}},
       If[btyp===s2D,{{mi, 0,  -mi cy[indexi]},
                      {0, mi,   mi cx[indexi]}, 
                      {-mi cy[indexi], mi cx[indexi], Izz[indexi]}},
       If[btyp===e2D,{{mi, 0, -mi cy[indexi], Ctx[indexi]},
                      {0, mi,  mi cx[indexi], Cty[indexi]}, 
                      {-mi cy[indexi], mi cx[indexi], Izz[indexi], Crz[indexi]},
                      {Ctx[indexi],Cty[indexi],Crz[indexi], 1}}]]]]
       
(*
:[font = text; inactive; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
Vektorhomegai[btyp_,indexi_] liefert eine nzi x 1 -Matrix der Kreiselkraefte  fuer Koerper indexi, je nach btyp.  mi ist die Masse.

:[font = input; initialization; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
*)
Vektorhomegai[btyp_,indexi_] :=  
       If[btyp===s3D,{{-(mi*(cy[indexi]*ox[indexi]*oy[indexi] + cz[indexi]*ox[indexi]*oz[indexi] + cx[indexi]*(-oy[indexi]^2 - oz[indexi]^2))) - mi*(-(oz[indexi]*vy[indexi]) + oy[indexi]*vz[indexi])},
                      {-(mi*(cx[indexi]*ox[indexi]*oy[indexi] + cz[indexi]*oy[indexi]*oz[indexi] + cy[indexi]*(-ox[indexi]^2 - oz[indexi]^2))) - mi*(oz[indexi]*vx[indexi]    - ox[indexi]*vz[indexi])}, 
                      {-(mi*(cz[indexi]*(-ox[indexi]^2 - oy[indexi]^2) + cx[indexi]*ox[indexi]*oz[indexi] + cy[indexi]*oy[indexi]*oz[indexi])) - mi*(-(oy[indexi]*vx[indexi]) + ox[indexi]*vy[indexi])},
                      {  Iyy[indexi]*oy[indexi]*oz[indexi]  - Izz[indexi]*oy[indexi]*oz[indexi] - mi*((-(cy[indexi]*oy[indexi]) - cz[indexi]*oz[indexi])*vx[indexi]   + cy[indexi]*ox[indexi] *vy[indexi] + cz[indexi]*ox[indexi] *vz[indexi])},
                      {-(Ixx[indexi]*ox[indexi]*oz[indexi]) + Izz[indexi]*ox[indexi]*oz[indexi] - mi*(   cx[indexi]*oy[indexi]*vx[indexi] + (-(cx[indexi]*ox[indexi]) - cz[indexi]*oz[indexi])*vy[indexi] + cz[indexi]*oy[indexi] *vz[indexi])}, 
                      {  Ixx[indexi]*ox[indexi]*oy[indexi]  - Iyy[indexi]*ox[indexi]*oy[indexi] - mi*(   cx[indexi]*oz[indexi]*vx[indexi] + cy[indexi]*oz[indexi]*vy[indexi] + (-(cx[indexi]*ox[indexi])  - cy[indexi]*oy[indexi])*vz[indexi])}},

       If[btyp===s2D,{{-(mi*(cx[indexi]*(- oz[indexi]^2))) - mi*(-(oz[indexi]*vy[indexi]))},
                      {-(mi*(cy[indexi]*(- oz[indexi]^2))) - mi*(  oz[indexi]*vx[indexi]) }, 
                      {- mi*(cx[indexi]*oz[indexi]*vx[indexi] + cy[indexi]*oz[indexi]*vy[indexi])}},


       If[btyp===e3D,{{-2*(  Ctqdz[indexi]*oy[indexi]  - Ctqdy[indexi]*oz[indexi]) - (mi*(cy[indexi]*ox[indexi]*oy[indexi] + cz[indexi]*ox[indexi]*oz[indexi] + cx[indexi]*(-oy[indexi]^2 - oz[indexi]^2))) - mi*(-(oz[indexi]*vy[indexi]) + oy[indexi]*vz[indexi])},
                      {-2*(-(Ctqdz[indexi]*ox[indexi]) + Ctqdx[indexi]*oz[indexi]) - (mi*(cx[indexi]*ox[indexi]*oy[indexi] + cz[indexi]*oy[indexi]*oz[indexi] + cy[indexi]*(-ox[indexi]^2 - oz[indexi]^2))) - mi*(  oz[indexi]*vx[indexi]  - ox[indexi]*vz[indexi])}, 
                      {-2*(  Ctqdy[indexi]*ox[indexi]  - Ctqdx[indexi]*oy[indexi]) - (mi*(cz[indexi]*(-ox[indexi]^2 - oy[indexi]^2) + cx[indexi]*ox[indexi]*oz[indexi] + cy[indexi]*oy[indexi]*oz[indexi])) - mi*(-(oy[indexi]*vx[indexi]) + ox[indexi]*vy[indexi])},
                      {-(Grxx[indexi]*ox[indexi]) - Grxy[indexi]*oy[indexi] - Grxz[indexi]*oz[indexi] +  Iyy[indexi]*oy[indexi]*oz[indexi]  - Izz[indexi]*oy[indexi]*oz[indexi] - mi*((-(cy[indexi]*oy[indexi]) - cz[indexi]*oz[indexi])*vx[indexi] + cy[indexi]*ox[indexi]*vy[indexi]  + cz[indexi]*ox[indexi] *vz[indexi])},
                      {-(Gryx[indexi]*ox[indexi]) - Gryy[indexi]*oy[indexi] - Gryz[indexi]*oz[indexi] - (Ixx[indexi]*ox[indexi]*oz[indexi]) + Izz[indexi]*ox[indexi]*oz[indexi] - mi*(cx[indexi]*oy[indexi]*vx[indexi] + (-(cx[indexi]*ox[indexi])  - cz[indexi]*oz[indexi])*vy[indexi] + cz[indexi]*oy[indexi] *vz[indexi])}, 
                      {-(Grzx[indexi]*ox[indexi]) - Grzy[indexi]*oy[indexi] - Grzz[indexi]*oz[indexi] +  Ixx[indexi]*ox[indexi]*oy[indexi]  - Iyy[indexi]*ox[indexi]*oy[indexi] - mi*(cx[indexi]*oz[indexi]*vx[indexi] + cy[indexi]*oz[indexi]*vy[indexi]  + (-(cx[indexi]*ox[indexi])  - cy[indexi]*oy[indexi])*vz[indexi])},
                      {-(Gex [indexi]*ox[indexi]) - Oe1[indexi]*ox[indexi]^2 - Gey[indexi]*oy[indexi] - Oe4[indexi]*ox[indexi]*oy[indexi] - Oe2[indexi]*oy[indexi]^2 - Gez[indexi]*oz[indexi] - Oe6[indexi]*ox[indexi]*oz[indexi] - Oe5[indexi]*oy[indexi]*oz[indexi] - Oe3[indexi]*oz[indexi]^2 - 
                       (-(Ctz[indexi]*oy[indexi]) + Cty[indexi]*oz[indexi])*vx[indexi] - (Ctz[indexi]*ox[indexi] - Ctx[indexi]*oz[indexi])*vy[indexi] - (-(Cty[indexi]*ox[indexi]) + Ctx[indexi]*oy[indexi])*vz[indexi]}},

                      
       If[btyp===e2D,{{-2*(- Ctqdy[indexi]*oz[indexi]) -(mi*(cx[indexi]*(- oz[indexi]^2))) - mi*(-(oz[indexi]*vy[indexi]))},
                      {-2*(  Ctqdx[indexi]*oz[indexi]) -(mi*(cy[indexi]*(- oz[indexi]^2))) - mi*(  oz[indexi]*vx[indexi]) }, 
                      {- Grzz[indexi]*oz[indexi] - mi*(cx[indexi]*oz[indexi]*vx[indexi] + cy[indexi]*oz[indexi]*vy[indexi])},
                      {- Gez[indexi]*oz[indexi]  - Oe3[indexi]*oz[indexi]^2 - Cty[indexi]*oz[indexi]*vx[indexi] + Ctx[indexi]*oz[indexi]*vy[indexi]}}]]]]

(*
:[font = text; inactive; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
Vektorhgi[btyp_,indexi_] liefert eine nzi x 1 -Matrix der Gewichtskraefte fuer Koerper indexi, je nach btyp.  mi ist die Masse.
:[font = input; initialization; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
*)
Vektorhgi[btyp_,indexi_] :=  
       If[btyp===s3D,{{gx[indexi]*mi},
                      {gy[indexi]*mi},
                      {gz[indexi]*mi},
                      {(-(cz[indexi]*gy[indexi]) + cy[indexi]*gz[indexi])*mi},
                      {(  cz[indexi]*gx[indexi]  - cx[indexi]*gz[indexi])*mi},
                      {(-(cy[indexi]*gx[indexi]) + cx[indexi]*gy[indexi])*mi}},

       If[btyp===s2D,{{gx[indexi]*mi},
                      {gy[indexi]*mi},
                      {(-(cy[indexi]*gx[indexi]) + cx[indexi]*gy[indexi])*mi}},

       If[btyp===e3D,{{gx[indexi]*mi},
                      {gy[indexi]*mi},
                      {gz[indexi]*mi},
                      {(-(cz[indexi]*gy[indexi]) + cy[indexi]*gz[indexi])*mi},
                      {(  cz[indexi]*gx[indexi]  - cx[indexi]*gz[indexi])*mi},
                      {(-(cy[indexi]*gx[indexi]) + cx[indexi]*gy[indexi])*mi};
                      {  Ctx[indexi]*gx[indexi] + Cty[indexi]*gy[indexi] + Ctz[indexi]*gz[indexi]}},

       If[btyp===e2D,{{gx[indexi]*mi},
                      {gy[indexi]*mi},
                      {(-(cy[indexi]*gx[indexi]) + cx[indexi]*gy[indexi])*mi},
                      {Ctx[indexi]*gx[indexi] + Cty[indexi]*gy[indexi] + Ctz[indexi]*gz[indexi]}}]]]]


(*
:[font = text; inactive; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
Varbetasz[btypi_,btypj_,indki_,inkj_,indexi_,indexj_] ermittelt den Winkel betasz (Drehung um z) ueber das Gelenk s 
VektorBs[btypi_,btypj_,betasz_] erzeugt eine 3 x 3 Dreh- Matrix fuer das Gelenk s (in der x-y-Ebene
:[font = input; initialization; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
*)
Varbetasz[btypi_,btypj_,indki_,indexi_,indkj_,indexj_] :=    
       If[btypi===s3D||btypj===s3D||btypi===e3D||btypj===s3D,
       	  {{Null},
           {Null}, 
           {Null}},
       If[btypi===s2D&&btypj===s2D,al[indexi]+gammaki[indki]               - al[indexj]-gammakj[indkj], 
       If[btypi===s2D&&btypj===e2D,al[indexi]+gammaki[indki]               - al[indexj]-gammakj[indkj]-thetaz[indkj], 
       If[btypi===e2D&&btypj===s2D,al[indexi]+gammaki[indki]+thetaz[indki] - al[indexj]-gammakj[indkj], 
       If[btypi===e2D&&btypj===e2D,al[indexi]+gammaki[indki]+thetaz[indki] - al[indexj]-gammakj[indkj]-thetaz[indkj],

       If[btypi===s2D&&btypj===I  ,  al[indexi]+gammaki[indki], 
       If[btypi===I  &&btypj===e2D,- al[indexj]-gammakj[indkj]-thetaz[indkj], 
       If[btypi===I  &&btypj===s2D,- al[indexj]-gammakj[indkj], 
       If[btypi===e2D&&btypj===I  ,  al[indexi]+gammaki[indki]+thetaz[indki]
        ]]]]]]]]];
 
 MatrixBs[btypi_,btypj_,betasz_] :=
       If[btypi===s3D||btypj===s3D||btypi===e3D||btypj===s3D,
       	  {{Null},
           {Null}, 
           {Null}},
          {{ Cos[betasz],  Sin[betasz], 0},
           {-Sin[betasz],  Cos[betasz], 0}, 
           { 0,            0,           1}}]
    

(*
:[font = text; inactive; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
Richtungsvektor aus ns bilden mit Vektor ns[vec1_,vec2_]
Kraftvektor fr(6) je nach typ bilden
:[font = input; initialization; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
*)
Vektorns[vec1_,vec2_,vec2Betr_] :=    
       If[Sqrt[vec1[[1]]^2+vec1[[2]]^2+vec1[[3]]^2]===0,

              {vec2[[1]]/vec2Betr,
               vec2[[2]]/vec2Betr,
               vec2[[3]]/vec2Betr},

              {vec1[[1]]/Sqrt[vec1[[1]]^2+vec1[[2]]^2+vec1[[3]]^2],
               vec1[[2]]/Sqrt[vec1[[1]]^2+vec1[[2]]^2+vec1[[3]]^2],
               vec1[[3]]/Sqrt[vec1[[1]]^2+vec1[[2]]^2+vec1[[3]]^2]} 
          ]
          
Vektorfr[rtyp_,vec1_,indexr_] :=    
      If[rtyp===F1, Flatten[{vec1*Fr[indexr],{0,0,0}}],
      If[rtyp===L1, Flatten[{{0,0,0},vec1*Lr[indexr]}] ]]

(*
:[font = text; inactive; preserveAspect]
   
   
   
   
   
   
   
   
   
   
   
   
   
:[font = text; inactive; preserveAspect]
phibarTGelenk bestimmt die Matrix phibar-Transpose fuer S, D, F und DS- Gelenke im 2D.  Dimension ncs * 6
mysDef2D bestimmt  die Matrix mys fuer S, D, F und DS- Gelenke im 2D, Dimension ncs
:[font = input; initialization; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981]
*)
Needs["LinearAlgebra`Orthogonalization`"];
phibarTGelenk[gtyp_,vecns_?ListQ] := 
      If[gtyp===D,
          {{1,0,0,0,0,0},
           {0,1,0,0,0,0},
           {0,0,1,0,0,0},
            Join[{0,0,0},RotateRight[vecns,1]],
            Join[{0,0,0},Tilde[vecns].RotateRight[vecns,1]]
           },
          If[gtyp===S,  
           {Join[GramSchmidt[{vecns[[Range[1,2]]],RotateRight[vecns[[Range[1,2]]],1]}][[2]],{0},{0,0,0}],
            Join[{0,0,1},{0,0,0}],
            {0,0,0,1,0,0},
            {0,0,0,0,1,0},
            {0,0,0,0,0,1}
           },
          If[gtyp===DS,  
           {Join[GramSchmidt[{vecns[[Range[1,2]]],RotateRight[vecns[[Range[1,2]]],1]}][[2]],{0},{0,0,0}],
            Join[{0,0,1},{0,0,0}],
            {0,0,0,1,0,0},
            {0,0,0,0,1,0}
           },
           If[gtyp===F, IdentityMatrix[6]
       ]]]] /; Length[vecns]==3 

(*
:[font = input; initialization; preserveAspect; backColorRed = 58981; backColorGreen = 58981; backColorBlue = 58981; endGroup]
*)
mysDef2D[gtyp_,ll1_] := 
      If[gtyp===D, {my[ll1],my[ll1+1],0,0,0},
        If[gtyp===S, {my[ll1],0,0,0,my[ll1+1]},
          If[gtyp===DS, {my[ll1],0,0,0},
            If[gtyp===F, {my[ll1],my[ll1+1],0,0,0,my[ll1+2]}
       ]]]] 

(*
^*)
